import { apiConfig } from '@/config/api.config';
import { useManageSucosContext } from '../hooks/useManageSucosContext';
import { useCallback, useState } from 'react';
import { useCallApi } from '@/hooks';
import { Alert, useDataGrid } from '@/components';
import { toast } from 'sonner';
import {
  Dialog,
  DialogContent,
  DialogDescription,
  DialogFooter,
  DialogHeader,
  DialogTitle
} from '@/components/ui/dialog';
import { Button } from '@/components/ui/button';
import { doSaveLogActivity } from '@/actions/GlobalActions';

const API_URL = apiConfig.service_master_data;

const DeleteDialog = () => {
  const { showDeleteDialog, handleDeleteDialog, selectedSucos } = useManageSucosContext();
  const { reload } = useDataGrid();
  const { DeleteData } = useCallApi();
  const [alert, setAlert] = useState({ show: false, message: '' });

  const doDeleteSucos = useCallback(async () => {
    if (!selectedSucos) {
      toast.error('No Sucos selected');
      return;
    }

    // Hanya soft delete (tanpa enforce)
    const response = await DeleteData(`${API_URL}/sucos/delete/${selectedSucos}/false`, {
      id: selectedSucos
    });

    if (response?.status) {
      setAlert({ show: false, message: '' });
      handleDeleteDialog(false, null);
      toast.success('Success Delete Sucos');
      reload();
      const createActivity = {
        module: 'Manage Sucos',
        description: `Delete Sucos => ${selectedSucos}`,
        action: 'D'
      };

      doSaveLogActivity(createActivity);
    } else {
      setAlert({ show: true, message: response?.message });
      toast.error('Failed Delete Sucos');
    }
  }, [selectedSucos, DeleteData, handleDeleteDialog, reload]);

  return (
    <Dialog open={showDeleteDialog} onOpenChange={(open) => handleDeleteDialog(open, null)}>
      <DialogContent className="container-fixed max-w-md flex flex-col p-5 overflow-hidden">
        <DialogHeader className="p-0 border-0 block">
          <DialogTitle></DialogTitle>
          <DialogDescription></DialogDescription>
          <Alert variant="warning">
            <h3 className="text-lg">Are you sure?</h3>
            <span className="text-sm">You will delete this data!</span>
          </Alert>
          {alert.show && (
            <Alert variant="danger">
              <h3>{alert.message}</h3>
            </Alert>
          )}
        </DialogHeader>
        <DialogFooter className="flex justify-end items-center gap-4 mt-3">
          <Button variant="outline" onClick={() => handleDeleteDialog(false, null)}>
            Cancel
          </Button>
          <Button variant="destructive" onClick={doDeleteSucos}>
            Delete
          </Button>
        </DialogFooter>
      </DialogContent>
    </Dialog>
  );
};

export default DeleteDialog;
